.. XddControl documentation master file, created by
   sphinx-quickstart on Wed Oct 12 16:17:58 2016.
   You can adapt this file completely to your liking, but it should at least
   contain the root `toctree` directive.

变更日志
===============

1.0
-----------

* 支持微信收款

1.1
-----------

* 支持所有支付方式

1.1.1
-----------

* 修复支付成功以后返回订单号问题

1.1.2
-----------

* 增加退款密码

1.1.3
-----------
* 增加通过详细商户信息进行弹出窗口支付
* 修改二维码生成，增加宽度

1.1.4
-----------

* 去掉pay方法中的key参数
* paymentByShop增加支付名称返回

1.1.5
-----------

* 增加数据上行接口data_upload

1.1.6
-----------

* 弹出支付增加导出条码参数
* 发送postmessage消息为2000给平台

1.2.0
-----------

* 添加外卖接单接口
* 添加外卖拒单接口
* 添加支付取消接口

1.2.1
-----------

* 修改支付界面，支持三种显示方式0全显示，1条码支付，2二维码支付

1.3
-----------

* 增加外卖助手

1.4
-----------

* 优化资源从4M到2M
* 解决退出报错问题

1.4.1
-----------

* 接单菜品数量问题，两个菜品，显示为一个。
* 增加unassistant，关闭助手
* 卸载相应资源

1.4.2
-----------

* 对网络状态判断更准确

1.4.3
-----------

* 接收处理结果

1.4.4
-----------

* 处理退款通知

1.4.5
-----------
* 转单成功或失败提示
* 外卖和支付分开句柄送消息
* 申请退款订单界面，里面的功能（同意、不同意），点了都没有反应
* 同意退单申请，需要通知线下软件，线下软件把对应的单据做退单做处理
  解决方法：同意退单是3001消息，wparam=orderId
* 转单失败，并且调拒单接口失败时，控件上的单据已经被删了，无法再对这个单做操作了
		    转单后传送消息给控件是否可以这样：
			send(hwnd,3000,0,orderid)  转单成功
			send(hwnd,3000,1,orderid) 转单失败，已拒单
			send(hwnd,3000,2,orderid) 转单失败，拒单失败 

* 有外卖单来了时候，前台没有登录控件，再登录控件也不会看到那笔外卖订单

1.4.6
-----------

* 申请退单界面，有些单据是不能点同意或者不同意的（拒退款、已退款的单），应该点了查看后，就删掉
* 申请退单界面没有显示用户退单的原因
* 外卖浮窗有时候没有显示在上面，会被线下软件挡住，看不见浮窗
* 退款界面显示的总价显示不对*
* 停留在浮窗点开界面，没有刷新来的单
* 饿了么调接单拒单接口返回-1
* 外卖单界面没有显示时间

1.4.7
-----------

* 增加返回网络状态
* 关闭二维码窗口自动取消订单

1.4.8
-----------

* 支付界面按ALT+F4关闭后，paymentByShop返回0
* 未接单的外卖单，用户取消订单，还可以转单（控件应该删掉无效的订单）

1.5.0
-----------

* 订单状态发生变化，不允许接单

1.5.1
-----------

* 增加送达时间和流水号

1.5.2
-----------

* 修复订单状态发生变化时接单
* 修复送达时间 立即

1.5.3
-----------

* 800*600
* 自动关闭加焦点
* 提示条码错误
* 增加ALT+X快捷键
* 增加支付方式控制

1.5.4
-----------

* 修复异常退出问题

1.5.4.2
-----------

* 转单成功未删除订单

1.5.4.3
-----------

* 修改按旧新方式排序（原新旧排序)

1.5.4.4
-----------

* 对确认订单加日志输出

1.5.5
-----------

* 对网络请求原来3秒，改成6秒，同时增加3次重试机会，所以最长有18秒时长，估计会造成暂时卡顿

1.5.5.1
-----------

* 输出404状态时，网址

1.5.6
-----------

* 在付款界面，输入条码后按确认后关闭按钮不能点，否则出现手机已付款，但系统中返回取消操作点关闭以后，也返回结果，如果断网产生订单号，来网时自行查询，如果在网会返回真实状态（未支付就取消，已支付返回成功结果）
* 查询、撤消、付款、退货各方式要有时间限制，发送之后如果断网一直没有返回时必须在多久强制返回值给系统
  这个只有付款存在这个问题，因为其它都是纯接口的都是立即返回方式，不存在一直等待,现解决方法（断网或其它错误，查询10次后（大约30秒），就跳转到失败）
* 在付款界面输入过期的付款条码或不正确付款条码后，应该给出提示并删除原有条码，现在是点了没反应
  现在是输错了，我会选中所有内容，自行删除即可，可以按你们的要求删除
* 付完款后窗口不会自动关闭，键盘按下回车键无效，必须鼠标点击关闭才可以；
* 付完款后手机已接收到信息完成付款，但是付款界面还在走动画效果，如果此时点关闭了，系统返回操作取消
* 偶尔出现第一次输入付款码后按回车没有反应，关闭后再进入付款就可以了
* 已修改过，因为没有提示条码无效，早已修复过
* 退货问题，同一个线上单号可以一直退货；如销售使用翼支付付款1块钱，退货时选择翼支付退款1块后，新的交易可以继续使用该单号退货
* 退货问题，不支持多次部分退货，如翼支付付款10元，第一次退2块，第二次退3块
* 增加多次退款接口与查询接口
* 接口上要支持键盘操作，如回车、退出键及相关快捷键；
* 退货问题，没有返回退货时选择的退货方式
* 这个支付的时候已经返回支付方式了，退货方式自然和支付一样呀，你们应该把支付时候的存一下
* 退货不支持查询退货结果功能，如线上退货成功，但网络不佳时线下接收不到，此时没有查询功能无法清楚是否完成退货；
* 消费查询功能，接口参数只支持线上单号，不支持线下收银小票，如果网络不佳的情况下，线上已完成付款，但是线下不知道，因此没办法去查询该交易是否完成

1.5.7
-----------

* 增加query2查询接口，通过科脉订单号查询订单状态，订单号不能重复
* 增加paymentByShop2接口，增加传科脉订单号

1.5.7.1
-----------

* 增加导出

1.5.7.2
-----------

* 测试环境

1.5.7.3
-----------

* 正在环境

1.5.7.4
-----------

* 条码支付，增加余额不足错误提示

1.6.0.1
-----------

* 外卖新版界面

1.6.0.2
-----------

* 修改外卖接单流程

1.6.0.3
-----------

* 增加自动接单

1.6.0.4
-----------

* 增加有效无效图标

1.6.1.0
-----------

* 发布正式版测试

1.6.1.1
-----------

* 清除测试数据
* 更改排序方式
* 已通知列表不要图标状态
* 修改只有在线支付才可以自动转单

1.6.1.2
-----------

* 清除失败订单号缓存1

1.6.1.3
-----------

* 清除失败订单号缓存2

1.6.1.4
-----------

* 访问网络优化，外卖所有请求改成异步操作，减少系统卡顿

1.6.1.5
-----------

* 修复自动接单列表不刷新问题
* 退款中列表改为从网络中获取，原为存储在本地数据库中。

1.6.1.6
-----------

* 在支付成功以后返回pay_result.txt文件，里面存放订单号，总价，实价，优惠价，优惠内容

1.6.1.7
-----------

* 增加异常捕获代码 

1.6.1.8
-----------

* 增加日志输出

1.6.1.9
-----------

* 修改支付成功后，两个线程之间共享变量造成死掉问题
* 待处理订单如果剩最后一个的时候不刷新问题

1.6.1.10
-----------

* 未处理列表不显示有效订单和无效订单图标

1.6.2.0
-----------

* 调整了卡券核销接口为异常方式
* 修复tab切换卡死现象

1.6.2.1
-----------

* 修复系统关闭控件进程还在的问题

1.6.2.2
-----------

* 修改转单机制每个单生成一个文件
* 增加每10秒检测一下未处理订单状态
* 已处理列表增加滚动分页功能

1.6.2.3
-----------

* 增加getErrorMessage接口，返回最后一次请求接口的错误信息，需要在返回值 >0时调用,通过界面操作的这个值无效。

1.6.2.4
-----------

* 增加“已在商家平台受理该订单”功能，商家 如果在其家平台处理了单，可以点击删除这个单

1.6.2.5
-----------

* 增加调试日志

1.6.2.6
-----------

* 增加餐盒费和餐盒数量

1.6.3.0
-----------

* 增加一码付，修改界面支付逻辑

1.6.3.1
-----------

* 慢机器造成支付结果返回0，造支付成功！

1.6.3.2
-----------

* 修复待处理订单，实际已经没有但是提示数字还是1
* 享多多支付：使用条码付款，输入条码按enter键后关闭付款窗口，线上支付成功，线下没有记录。
* 享多多支付：扫描二维码付款，在线上点击“确认付款”，同时关掉线下付款窗口，会造成线上支付成功，线下没有记录。
* 享多多支付：付款时选择二维码支付，此时打印出二维码，关闭付款界面，扫描打印出来的二维码，付款成功，但线下没有任何记录，也不会产生小铃铛。导致付的钱无法退回去。问题备注：微信支付和大众闪惠存在该问题，其它付款方式无此问题。
* 因微信支付和大众闪惠无撤销接口，所以对打印出二维码能继续支付，变通解决方法，因为只要是生成了二维码就会有线上订单号和线下订单号，出现问题时科脉拿这两个订单号都可以查询
* 享多多支付-账前预打支付二维码：选择“两者都打印”，打印账单后，不支付，再次打印账单，不管选择哪种二维码显示方式，账单上都不显示二维码。(在重新打印二维码的时候会先撤销第一次打印的且未付款的记录, 这个时候撤销失败导致新的二维码没有生成)
* 享多多支付：打开扫条码窗口，放置一半个多小时后再扫描，均提示条码无效，不能支付。
* 享多多支付：使用京东支付，扫条码之后提示“网络错误”，如图。之后手机端提示“系统正在开小差，请稍后重试”。
* 享多多外卖：线上已取消订单，享多多控件里还显示这张单，选择这张单进行转单，提示“享多多外卖接单失败，调用线上接单函数失败”。如图
* 享多多外卖：线上下单超时，已经取消订单了，但享多多外卖控件未刷新，线上已取消的订单一直在待处理中。如果选择转单或者已在其他商户平台接单，则程序会退出，提示"kmcy.exe未响应"。如图
* 享多多支付：先使用正确的商务号设置接口，并在前台使用线上支付付款方式，此后使用无效的商务号设置接口，仍可正常使用线上支付付款方式。
* 享多多支付：使用QQ钱包付款后不能撤销，提示撤销失败。(陈工说有QQ钱包有双重密码, 是第二重密码错误导致，但是没有地方设置第二重密码)
* 享多多支付：付款时选择二维码模式，点击“翼支付”后不会显示支付二维码。
* 前台使用享多多条码支付，如果使用的是关联的银行卡，会提示条码无效，切换成余额后可以付款成功
* 享多多对接：输入条码后连接不到享多多服务器，现会卡住且没有任何提示(现在会改成提示条码无效，单很提示不明确)
* 享多多外卖：勾选“自动转单”，下一次登录的时候又变成了未勾选的状态，建议记住上一次的设置(这个测试说要改的,)
* 这个最好争取用户习惯，启动时自动沟选不好（比如设备可能还没有就绪等）
* 享多多外卖：不打开前台，百度外卖，第一分钟下单，弟4分钟下单，第12分钟打开前台，第一单过期，第二单还未过期，但这两单都在已处理-全部中显示为有效状态
* 享多多外卖：启用自动转单，享多多控件最小化，下单成功后，一直显示的是待处理订单为1，但百度线上显示已接单了
* 享多多外卖：接单pos断网了，下单直到此单在线上被取消，再连上接单Pos的网。此时线上已取消此单，但享多多控件已处理-全部会有此单。已处理-有效/无效订单中无此单
* 享多多外卖：百度超时时间是10分钟，中途退出软件，在线上下单，再第一单还有两分钟左右才超时时，进入软件前台，此时待处理只有最新的第二单，之前的那一单在百度平台都还未超时，但没显示在控件的待处理中，且会在已处理-全部中显示此单为有效订单，在有效和无效中找不到此单。一段时间后，有效订单状态会被刷成无效订单
* 享多多外卖：百度线上超时，取消订单了。享多多控件未刷新，还在待处理中。点击转单，提示订单已取消，但在已处理的全部订单中显示此订单状态为有效订单。有效订单和无效订单中无此单
* 享多多外卖：有两个待处理订单，都没有过期，退出前台重新进了下，待处理变成一个了，订单下的较早的那个未显示在待处理中了
* 享多多外卖：有待处理订单，中途断网，数据库连接断掉。重新打开前台控件，待处理订单就没有了，已处理订单有此订单。如图
* 享多多外卖：未转单的订单，在已处理-订单状态“全部”中也会显示，且状态是有效订单。

1.6.3.3
-----------

* 修改查询接口query2，返回线上订单号

1.6.3.4
-----------

* 增加外卖导出外卖平台当日流水号thirdDaySeq
* 加每日订单流水号是为了解决第三方配送查单的问题。外卖的骑手拿着的是各自平的订单，到商家用每日订单流水号做比对，如果没有各自平台的流水号，那骑手与商家就需要对比电话号码、地址、菜品信息去确认订单是否正确，非常麻烦。目前红荔村、云味馆非常迫切需要这个功能，所以erp打单也需要在明天测试上线。
* 优化网络检测，如果启动代理服务器的话，网络检测不准确

1.6.3.5
-----------

* 外卖浮窗启动时，如果登录踢出，发送窗体消息3002

1.6.3.6
-----------

* 调试版本(推送355错误码处理)

1.6.3.7
-----------

* 增加自动接单全局配置，重启以后可以保存
* 增加网络1分钟无订单，补单机制
* 补单过来也自动打印

1.6.3.8
-----------

* 优化日志输出

1.6.3.9
-----------

* 控件订单列表显示日流水号

1.6.3.10
-----------

* 增加平台切换导出函数

1.6.3.11
-----------

* 测试版本，增加paymentByShop2日志 输出

1.6.3.12
-----------

* 避免重复调用init函数

1.6.3.13
-----------

* 修复卡券显示bug

1.6.3.14
-----------

* 卡券核销成功返回json
* 传入参数如果有空格会造成网络错误

1.6.3.15
-----------

* 卡券核销转成GBK码
* 增加pay2接口用于无界面支付传第三方订单号

1.6.3.16.20161011
----------------------

* 外卖平台增加【平台承担费用，商家承担费用，平台服务费，商家实收】相关数据

1.6.3.17.20161021
----------------------

* 券核销：前台使用团购券付款，输入错误或不存在的券号，点击验证，没有任何反应，建议给出提示。
* 券核销：使用团购券付款，核销后，点击右上角的关闭按钮，线下无该笔付款记录，但券已被核销。
* 券核销：仅启用券核销，在前台使用团购券付款方式，提示参数错误，
  如图。必须同时启用线上支付，才能使用团购券付款方式。
  回复，必须调用login和shop才可以用
* 券核销：前台使用团购券付款方式，输入券号后，不选券类型，点击“验证”，没有反应，建议给出提示“请选择卡券类型”。
* 付款界面输入券号后，断网，点击“验证”，无反应，建议此时给出提示；
* 在核销界面，断网，点击确认核销，无反应，建议此时给出提示。

1.6.4.0.20161022
----------------------

* 控件增加自动升级功能

1.6.4.1.20161104
----------------------

* 修复BUG

1.6.4.2.20161121
----------------------

* 修复条码支付跳转到支付中页面自动返回问题

1.6.4.3.20161125
----------------------

* 暂时去掉糯米券核销，因为无法返回原始价格
* 对于核销券小于9个数字的给予提示

1.6.4.4.20161127
----------------------

* 修复针对饿了么平台特殊字符造成解析错误，造成订单不能处理
* 增加payment_param接口，用于传递支付附加参数，如果支付的商品信息
* 增加接到外卖通知，回复确认协议
* 选择二维码或条码支付时，禁用另外一种方式

1.6.4.5.20161130
----------------------

* 暂时注释掉外卖确认协议

1.6.4.6.20161208
----------------------

* 增加外卖确认协议

1.6.4.7.20161209
----------------------

* 商户注册由原来get改成post提交，解决乱码字符和特殊字符

1.6.4.8.20161210
----------------------

* 增加版本参数，以区别版本号

1.6.4.9.20161219
----------------------

* 发布测试版本

1.6.4.10.20161220
----------------------

* 支付订单查询增加扩展属性文件，用于返回支付名称等其它属性
  order_no|total_amount|amount|coupon_amount|coupon_memo|payment_method_name
  订单号|总价|支付金额|优惠金额|优惠备注|支付名称
* 调试打折金额，签名错误

1.6.4.11.20161221
----------------------

* 增加新美大30S心跳包
* 调试转单问题

1.6.4.11.20161222
----------------------

* 增加新美大外卖类型
* 增加新美大列表搜索

1.6.4.13.20161228
----------------------

* 转正式环境版本

1.6.4.14.20161230
----------------------

* 支付过程中如果禁用网卡会造成异常死掉
* 享钱支付（条码模式）：输入9位及9位以上的错误条码，提示“不支持此支付方式”，修改成为“输入条码错误”。
* 享钱支付（条码模式）：不输入条码或条码位数小于9位数，回车，无提示。修改成为“输入条码错误”。
* 修复通过第三方订单号查询query2，对query_result.txt不能更新问题
* 增加新美团券核销
* 弹出错误信息优化

1.6.4.15.20170108
----------------------

* 修复初始化init函数，因为没有try，导至如果日志文件创建失败，会卡死无法弹起支付

1.6.4.15.20170108
----------------------

* 修复初始化init函数，因为没有try，导至如果日志文件创建失败，会卡死无法弹起支付

1.6.4.16.20170109
----------------------

* 增加默认支付方式选择类型3，默认切换到条码支付

1.6.4.17.20170111
----------------------

* 输出每2秒一次的查询日志
* 支付超时由10分钟，调整为1.5分钟

1.6.4.18.20170215
----------------------

* 修改快捷显示
* 增加百度外卖授权方式
* 修改内部数据库结构

1.6.4.19.20170220
----------------------

* 增加获取当前门店所有支付方式与开通标志，getPayList(char* json),json预留空间最好不少于1000空间。
  格式：
      [{"pay_type":1,"channels":"ALIPAYCHANNELS","switch_flag":"0","chann_desc":"支付宝"}]
* 修改默认显示支付方式为条码支付

1.6.4.20.20170222
----------------------

* 增加paymentEx(float money, char* order_no, char* order, char* payName, int viewType = 0)接口，用于调用shop接口后，直接调用这个来发起支付，免去每次同步商户信息。
* 增加payment_result(int type,char* value）接口，用于返回支付结果中相关字段，增加扩展性以后如果增加返回值可以增加相关类型就可以
  type:现有如下取值：
                  100：读取支付名称
                  101：读取线上订单号
                  102：读取是二维码支付还是条码支付
  比如：调取支付名称：
                  payment_result(100,value);value中会包含支付名称

1.6.4.21.20170226
----------------------

* 修复超时关闭时没有调用取消订单
                  
1.6.4.22.20170303
----------------------

* query2接口:增加返回商家优惠金额和描述

1.6.4.23.20170307
----------------------

* 订单详情的字体颜色改深色一些，目前太淡了，滚动条区域加宽，关闭按钮范围也加大。
* 自动转单 改为 自动接单，包括按钮。

1.6.4.24.20170313
----------------------

* 1、扫描枪支付整个过程大约需要8秒；我们需要在2秒内完成整个支付过程。
  回复：这个2秒不现实，因为商家打开支付界面，拿起枪，再扫用户条码，我看好多日志输出都在5秒左右才拿到条码，发起支付请求1-2秒左右，查询结果1-2秒
* 2、二维码支付选择付款方式后到显示二维码需要1-2秒。
  回复：这个1-2秒应该算是正常，经过测试和日志分析，生成二维码的过程是这样：首先请求微信或支付宝等第三方平台接口获得二维码数据（几百毫秒），然后再入享多多数据库（几百毫秒），再返回控件端根据网络不同需要（1秒左右或几百毫秒），再到把字符转成二维码图形数据（几十毫秒）
* 3、网络不好时，点击控件上的“关闭”页面会显示空白。
  回复：因为关闭按钮时会调用关闭支付接口（取消支付接口）因采用同步请求方式会造成卡，解决方法是采用多线程方式，不卡界面就不会有显示空白。
* 4、支付页面需要增加倒计时。
* 5、支付成功后不需要再倒计时3秒，应直接返回。
* 6、输入条码后立即断网，此时控件会卡死。
* 7、控件上的提示信息不完整，被截断了。
* 8、查询接口没有返回优惠金额。
* query2已增加返回商家优惠和平台优惠
* 9、在某些xp的操作系统上享钱控件调不起来。

1.6.4.25.20170313
----------------------

* 测试环境与正式环境切换，优化订单支付时间由原来的2秒轮询改为长连接方式，使支付时间减少1-2秒时间

1.6.4.26.20170314
----------------------

* 优化支付时间
* 外卖导出增加发票相关字段
  hasInvoiced：是否开发票  0不需要，1需要，  invoiceTitle：发票抬头

1.6.4.27.20170323
----------------------

* 尝试修改扫码枪少一位问题，微信不再出现，但是支付宝还有时出现，继续改进。

1.6.4.28.20170328
----------------------
* 增加返回线上状态接口
* 自定义拒单界面
* 支付宝少一位
* 外卖列表界面增加，erp补单 消息为3020
* 线上平台已接单按钮会给erp导出 消息为3010
* 所有关闭快捷键改成ESC


1.6.4.29.20170405
----------------------

* 由于条码位数不够导致支付失败时，没有返回支付名称，造成程序异常退出。


1.6.4.30.20170406
----------------------

* 外卖增加平台配送转自配送导出，消息为3030  在xdd_data\目录下面生成order_delivery.txt，里面有订单json数据。


1.6.4.31.20170411
----------------------

* 外卖菜品中如果餐盒数量和价格出现null时造成程序死掉。


1.6.4.32.20170415
----------------------

* 退款中订单列表增加红色标识提配。
* 3030消息，文件存储规则按订单号命名文件，原来order_delivery.txt，改为 实际订单号.txt
* 修复3020消息中菜品编码为科脉编码，原来为享多多编码。


1.6.4.33.20170417
----------------------
* 修改 登录标识无效标识  为 请重新登录，同一个营业员不能登录多台机器，检查当前收银员已在其它的收银机登录前台并使用享钱支付。
* 取消所有关闭订单时的  取消订单接口。
* 修改网络检测函数，在断网时5秒内返回。


1.6.4.34.20170420
----------------------
* 优化网络检测Ping和Socket相兼容，速度提升，断网时最坏5秒
* 修复部分机器外卖新订单声音无法播放
* 修复拒单窗口被遮挡


1.6.4.35.20170426
----------------------
* 修复如果设置代理时，网络检测用Socket，禁用PING
* 修复支付时如果传输特殊字符℃ 单位字符等，造成的登录标识无效
* 修复支付时可能支付名称和订单返回空
* 界面中加入版本号标识


1.6.4.36.20170509
----------------------
* 修复PING网络检测BUG
* 支付成功后没有输出pay_result.txt文件，使ERP读取上次结果，需服务端处理 
* 增加沽清接口food_sold_out
* 增加菜品编码绑定接口food_code_bind


1.6.4.37.20170511
----------------------
* 修改bug


1.6.4.38.20170516
----------------------
* 日志被占用问题
* 支付查询超过31次，正好成功，没有生成支付结果文件，造成读取上一次，但是还是建议ERP，读完文件把文件删除或把内容清空。
* 断网时支付拿不到支付结果时，控件的支付接口返回给我们的是支付失败1
* 二维码模式，断网之后再选择支付方式后接口返回值是“-1”

1.6.4.39.20170525
----------------------
* 修改背景窗口图片，取消UI半透明属性（某些低版本系统下暂无法支持）
* 同步执行http超时设定6秒，重试3次
* 营业员无法换号登录的问题

1.6.4.40.20170527
----------------------
* 修改升级文件替换问题
* 升级成功自动关闭，网络问题失败重试三次。
* 添加非强制升级校验与提示。
* 修复http同步执行卡死问题，超时10秒，弹出网络错误提示
* 一些代码整理优化

1.6.4.41.20170601
----------------------
* 修改升级兼容性，修复某些系统提示失败且dll給删除的问题
* 修改日志机制，去除原有日志库，变更为可共享读写
* 修复一些代码中可能引起问题的地方
* pay_result结果取消换行符
* 修复外卖补单

1.6.4.42.20170605
----------------------
* 增加food_sold_out，food_full导出函数

1.6.4.43.20170605
----------------------
* 修复退出时http线程池死锁的问题

1.6.4.44.20170614
----------------------
* 取消退出时http释放资源等待，避免线程給干掉无限死等的问题
* udp更改为全局单例，地址更改为动态获取，优化相关处理逻辑
* 添加日志上传
* 添加一些基础功能方法
* 外卖逻辑优化，与udp通信模块分离
* 修复googleproto多线程可能崩溃的问题
* 修改数据库foodinfo orderId字段为UNIQUE，避免多线程数据错乱问题
* 去除一些不必要的全局变量
* 增加food_code_bind导出函数
* 修复外卖通信时某些字段为null时崩溃的问题
* 一些其他代码整理和优化
* socket实现icmp协议，避免一些电脑使用windows api ping出现奇怪的问题
* 为每个导出函数添加强制初始化，避免一些未调用init导致的奇怪问题

1.6.4.45.20170615
----------------------
* 取消所有线程池退出时的等待操作,dll卸载时再次释放所有全局变量，防止有些科脉产品未调用unassi接口导致死锁
* 添加多张卡券核销

1.6.4.46.20170621
----------------------
* duilib库小修改，规避有些老旧电脑无法绘制透明窗口问题
* 添加外卖窗口边缘自动变成缩小窗口，鼠标点击、悬浮在小窗口上，会变回普通窗口
* 添加退款声音提示
* 删除icmp库资源文件
* 修复外卖网络状态显示可能有误的问题
* 添加外卖口袋字段，导出文件
* 修改udp第一次连接时重试间隔，避免长时间显示网络延迟

1.6.4.47.20170622
----------------------
* 启动卡券核销窗口后，无法再进行支付的问题

1.6.4.48.20170627
----------------------
* 控件内部同步执行http失败不重试，超时10秒
* 修复扫码概率性少一位的问题

1.6.4.49.20170629
----------------------
* 支付修改为add2接口，免密支付成功变更为一次性返回不用查询，修改支付下单后处理逻辑
* 支付下单返回失败，改为倒计时3秒关闭窗口
* 修复支付异常返回的情况下，有可能出现实际失败却返回成功或者解析json崩溃的问题
* 缩小支付界面到500*600，为支持最小800*600分辨率
* 添加json公用安全解析函数

1.6.4.50.20170711
----------------------
* 规避有些电脑ping包返回type不正常的问题，当作成功
* 修复800*600分辨率下，支付窗口要移动一下才能完全显示的问题


1.6.5.0.20170721
----------------------
* json解析优化修改，避免越界、特殊原因解析可能出错等问题
* 添加外卖接单池，Asyn_food_confirm异步接单函数
* 添加udp取消外卖消息通知
* 添加外卖taxerId字段
* 代码优化，整合抽象公共函数，删除不需要的多余文件代码等
* 外卖单标题UI显示不全的问题
* 报错不取消自动接单，接单报错错误显示在每个单上，不再弹窗
* 添加新启动外卖函数，应对将来可能的订单号过长问题（暂未导出，不开放使用）
* 添加智能指针，针对多线程安全优化等
* 添加一些日志和函数

1.6.5.1.20170727
----------------------
* 修复一些内存泄漏
* 整理删除冗余代码，优化控件消耗资源
* geterrormessage线程安全化，变更为获取当前线程最后一次出错的信息，避免出现混乱的信息
* 更新数据库为20170724，添加一些config字段
* 添加gps信息上报，国测局坐标
* 添加udp消息过滤机制，防止消息重复处理
* udp心跳变更为1分钟一次，延长检测超时时间
* 添加assistant2、food_refund2、food_cancel2导出函数，规避未来id号可能过长的问题
* 添加food_his_query_file函数，查询历史订单数据
* 初始化操作移至dll加载时

1.6.5.3.20170729
----------------------
* 网络检测强制返回成功，后续不做支持
* 外卖接单池重试改为延迟10s
* 去掉一些全局变量

1.6.5.4.20170810
----------------------
* 取消卡券核销全局变量 
* 修改添加一些日志
* http代理线程安全化
* 启用http代理，不进行udp通信
* 代理设置接口支持取消http代理，ip填空即可
* 登录信息线程安全化
* 自动升级变更为登录后进行请求，请求成功后该次进程不再重试
* 修改payScan和Export两个接口为不支持（原来会崩溃）
* 忽略notifyResponseCommand的udp响应消息
* 数据库内一些配置项改为不存在自动插入
* 修复订单状态图片错误
* 添加接口，pay_query_file根据支付订单号，返回订单详细信息

1.6.6.0.20170819
----------------------
* 添加达达配送功能
* 添加异步http线程池线程数和超时设置
* 添加时间转换函数异常处理
* messagebox返回值bug
* 取消外卖换肤功能
* 修复外卖错误乱码问题
* 数据库添加配送扫单缓存表，更新数据库
* 添加修改大量皮肤文件，皮肤数组更新
* 登录添加获取app功能支持
* 优化udp登录效率
* 修改一些日志为英文 避免老有客户问
* 外卖窗口修改为同步关闭，同时增加请求计数，避免关闭后可能引起的崩溃问题

1.6.6.1.20170823
----------------------
* 资源卸载移至unassistant函数中，http和udp线程改为等待安全退出
* 外卖取消新美大筛选选项
* 所有异步请求窗口添加引用计数，待所有请求返回后安全退出
* UIItemList支持序号插入，配送派单扫单改为新扫描的在最上方
* 修复是否支持配送判断bug
* 修复配送窗口背景图片没有下边缘的问题

1.6.6.2.20170825
----------------------
* 支付流程返回码优化，添加基于线程的错误信息保存
* 删除调整冗余代码

1.6.6.3.20170830
----------------------
* 添加外卖浮窗配置界面，所有外卖可配置项移至该界面
* 添加声音提醒配置，不提醒、提醒一次、自定义
* 添加接单异常声音提醒
* 添加声音处理服务，对所有需要播放的声音进行统一处理
* 添加外卖启动时自动接单日志打印，自动接单状态修改时日志打印
* 修改工程cpp编译顺序
* 添加json配置文件，可外部修改，优化配置项读写效率
* 修复大部分getErrorMessage获取信息不对的问题
* 一些日志打印信息修改，便于问题排查

1.6.6.4.20170906
----------------------
* 配送新增基础配送费展示
* 配送订单页面LOGO及抬头位置缩小空间
* 配送订单筛选按钮样式变更
* 配送待派单改成待审核
* 配送待审核页面加小费采用九宫格（0-8元），待接单页面加小费通过加加减减的形式添加小费
* 配送地址过长显示优化省略号
* http get请求参数url转义处理，支持空格等特殊字符
* 待派单页面改为直接以0小费派单到服务器
* 添加配送单状态变化udp通知

1.6.6.5.20170908
----------------------
* 修改了支付中的用户状态提示信息的字体位置颜色和大小
* 修复1.6.6.4版本，配送基础配送费取值错误问题
* 修改配送待接单页面，小费添加窗口金额限制为1-9
* 修改添加小费时上一次操作错误一直存在的问题
* 修改带界面支付，支付界面启动前失败的信息会弹出错误提示
* 界面支付，在下单失败的情况，有第三方订单号的情况下，会通过第三方订单号查询一次，成功则返回成功，失败则返回下单的结果
* 默认错误提示语变更为 网络异常，请检查网络

1.6.6.6.20170908
----------------------
* 修复UI库无法显示浮窗提示的bug
* 修改配送功能，鼠标悬停地址时会显示完整地址浮窗提示

1.6.6.7.20170911
----------------------
* 添加获取最后一次错误信息安全函数GetErrorMessage_s
* 修复商户登录问题，登录成功才记录当前登录商户。避免第一次登录失败后非要重启才能重新登录的问题
* MessageDialog无法弹窗bug修复
* 添加UnInit函数，用于控件资源卸载，取消unassistant中资源卸载

1.6.6.8.20170912
----------------------
* 配送项，时间过长的背景色改为大红。针对UI位置不正确的调整

1.6.6.9.20170913
----------------------
* 修复一些错误信息没设置的问题
* 增加了一些外卖日志打印，方便调试
* 添加通过文件映射id异步接单接口Asyn_food_confirm_fileID

1.6.6.10.20170914
----------------------
* 配送标题按钮鼠标移上去效果
* 一次支付界面启动限制只允许一次下单
* 支付结果不由支付界面UI库返回值获取，规避一些奇怪的返回值问题
* 支付登录失败等提示框改为与支付窗启动时统一风格

1.6.6.11.20170915
----------------------
* 暂时取消配送实时变更订单消息，避免导致崩溃

1.6.6.12.20170918
----------------------
* 恢复配送实时刷新订单状态功能，添加延迟状态变更
* 配送扫描订单关闭按钮变大

1.6.6.13.20170925
----------------------
* 配送，5-10分钟的订单背景改为深黄
* 配送，添加订单投诉功能
* 配送，一级标题添加个数提示显示与定时校正
* 配送，添加追加订单功能
* 配送，添加背景色超时自动变化
* 配送，订单页面变更为查询1个自然日内的订单
* 配送，添加距离显示
* 配送，修复待审核页面，基础配送费显示问题
* 登录时添加与服务器时间差计算

1.6.6.14.20170926
----------------------
* 配送，添加订单搜索功能
* 配送，添加派单时长筛选条件
* 修复一个UI库edit控件可能导致崩溃的bug
* 配送，修复派单后，外卖下单日期时间不对的问题 
* 修改弹出提示框关闭按钮位置不好看的问题

1.6.6.15.20171011
----------------------
* 配送，添加加小费历史记录查看
* 添加UI库提示框换行功能 
* outputdebug过滤release版本下的操作（优化发布版本一些函数的效率）
* 配送，添加配送派单超时提醒检测，相关资源文件更新
* 添加展开、收起筛选栏功能，可展现更多订单
* 配送，加载订单同时获取角标个数
* 配送，修复悬停多次获取小费问题
* 修复UI库提示栏闪烁问题

1.6.6.16.20171011
----------------------
*添加会员充值功能

1.7.0.0.20171017
----------------------
*低版本编译器移植，添加一些老旧硬件和系统的支持。

1.7.0.1.20171019
----------------------
*外卖修复UILib库，已处理页面返回顶部无效的问题
*外卖修复已接单备注不显示的问题
*外卖修复页面上立即送达、姓名文字显示不全的问题
*外卖修复断网时点击“拒单”和“已在商家平台受理该订单”不会有提示信息的问题
*外卖添加修改一些日志打印便于排查问题
*外卖修复已处理中百度图标不显示的问题
*外卖修复拒退款单判定为无效单的问题
*达达配送将原取消订单页面分为取消订单和异常订单
*达达配送小费、基础配送费字体调大，订单时间等信息字体调小
*达达配送订单各时间段显示优化，将纵向的时间横向显示
*达达配送添加超时自动重新派单功能
*达达配送将订单序号字体颜色设置为外卖类型背景色

1.7.0.2.20171108
----------------------
*合并独立外卖软件
*支付，过滤第三方订单号中的空格
*支付，修复二维码界面，不存在的快捷键导致崩溃的问题
*配送，修复待审核插入本地数据库时没插入小费的bug
*配送，待取货增加背景色随时间变化的功能
*配送，界面效果细节微调
*增加悬浮提示框
*增加一些错误码定义以及提示
*添加打印缓存队列和异步回调机制
*独立外卖，后台打印失败自动重试10次，每次间隔10秒
*完善网络打印机类，支持字体变化和各种属性设置等
*添加网络打印机类检测机制

1.7.0.3.20171109
----------------------
*启动时自动清空临时本地配置项
*打印增加一种没纸错误判断
*独立外卖，发配送界面点x也会发送问题
*修复打印函数一些不安全的json解析
*配送，错误信息添加鼠标悬停时提示
*配送，订单排序增加反序排列
*配送，主页面高度可调节

1.7.0.3.20171109
----------------------
*启动时自动清空临时本地配置项
*打印增加一种没纸错误判断
*独立外卖，发配送界面点x也会发送问题
*修复打印函数一些不安全的json解析
*配送，错误信息添加鼠标悬停时提示
*配送，订单排序增加反序排列
*配送，主页面高度可调节

1.7.0.4.20171114
----------------------
*支付，修复几个支付函数低概率返回错误的问题
*独立外卖，添加分单打印菜品选择
*独立外卖，修正并完善后台接单打印重试机制
*添加多种通用加密方法
*独立外卖，登录密码加密

1.7.0.5.20171117
----------------------
*添加图片解析库
*添加驱动打印类
*修复json中带有生僻字会可能导致解析失败的bug，该修改影响较大
*独立外卖，添加新打印解析类
*指令打印机类，添加reset还原默认字体 
*所有http请求添加_terminal_type_字段，标识终端来源
*/api/wm/order_list_trans，历史订单查询，添加字段confirm_from，标识接单终端来源
*控件外卖，添加每30分钟自动校正非pc接单自动同步功能
*异步接单wparam变更为外卖小窗口句柄
*修复一些支付接口没第三方订单号无法下单的问题

1.7.0.6.20171121
----------------------
*独立外卖，修复打印副单标题过小的问题
*修复一些debug日志打印中文乱码的问题

1.7.0.7.20171122
----------------------
*添加food_auto_sync接口，用于开启自动同步第三方订单数据

1.7.0.8.20171124
----------------------
*控件增加添加订单失败语音提醒功能
*控件增加订单超时重派次数显示在界面上功能
*控件增加自动添加小费功能
*控件已完成页面增加订单排序功能，排序现在支持正序和反序
*控件页面上时间间隔最大精确到分钟(之前是小时)
*控件增加自动派单功能
*控件设置界面更新
*外卖添加food_auto_sync自动同步导出函数

1.7.0.9.20171127
----------------------
*外卖修复导出订单为utf8字符的问题

1.7.0.10.20171128
----------------------
*外卖修复补单导出为utf8的问题
*添加code128条码加密算法
*添加驱动打印多种打印字体和方法
*添加驱动打印条码打印接口
*独立外卖修改打印协议，添加驱动/网络打印两种方式
*修复驱动打印垂直位置计算错误的问题
*添加网络打印，code18B条码打印功能
*独立外卖打印接口样式微调
*控件修改自动派单时间设置方式

1.7.0.11.20171201
----------------------
*修改当天日志大于一定程度也不更换文件的问题
*打印样式微调
*修复网络指令打印机对北洋打印机空行不生效的问题
*外卖添加http拉单网络日志
*独立外卖打印订单协议调整
*独立外卖右键添加菜单
*独立外卖增加显示和打印每日账单功能

1.7.0.12.20171204
----------------------
*控件修复自动添加小费功能和自动重新派单功能不触发的问题
*数据库更新
*日志更新

1.7.0.13.20171207
----------------------
*独立外卖，添加时间记录页面
*配送，添加订单失败语音提醒更换
*打印条码添加文字显示
*针对北洋打印机修复一些兼容性问题
*修复独立外卖
*修复一些独立外卖与控件互相影响问题
*一些界面UI的样式美化
*优化网络打印多列打印样式
*打印，添加多列打印列宽调整
*主打印区，打印菜品样式优化，菜品名称占更大位置
*修改自动同步，获取所有可能漏单、每次轮训的开始时间变更为上一次的结束时间
*修复几个后台线程操作UI导致概率性崩溃的问题
*修复退款订单有些类型没图标的问题

1.7.0.14.20171208
----------------------
*控件修复达达自动派单选中区域错误显示的问题

1.7.0.15.20171213
----------------------
*独立外卖，添加打印条码，条码文字，对齐方式等优化
*独立外卖，添加打印图片，图片对齐方式
*独立外卖，添加时间记录功能页面
*卸载资源uninit设置为未登录状态，shop接口可重新登录
*打印机库一些bug和算法相关优化
